//
//  bank.h
//  
//
//  Created by Melanie on 11/11/14.
//
//

#ifndef _bank_h_
#define _bank_h_

#include <vector>
#include "Theme.h"
#include "Variation.h"
#include "y-entity.h"

//holds all of the melodies in the fantasy
class Bank : public YEntity  {
    
public:
    Bank(int size, int melodyLength, bankKey key);
    ~Bank();
    Melody* getCurrentMelody();
    
    std::vector<Melody *> melodic_input;
    void playBank();
    
    int active_melody;// melody currently being edited/displayed
    int active_track;
    int active_tracks;
    
/** entity virtual void methods **/
    
    // use this for anything that even remotely effects the world state.
    void update( YTimeInterval dt ) { };
    
    // renders entity (assumes transforms, etc have been applied)
    void render();
    
    // updates you need to do after render; this is somewhat of a hack,
    // needed by FX to get GL state in render before it can update
    void updatePostRender( YTimeInterval dt ) {};
    
    // updates with all children
    void updateAll( YTimeInterval dt ) {};
    
    // draws with all children
    void drawAll() {};
    
    // all post-render updates
    void updateAllPostRender( YTimeInterval dt ) {};

    void newStep(int step);
    void selectTrack(int track_id);
    void toggleNote(int step);
    
};
#endif


