//
//  clock.cpp
//  
//
//  Created by Melanie on 10/21/14.
//
//

#include <iostream>
#include "clock.h"

//clock constructor
Clock::Clock(float sr, float t) {
    reset();
    tempo = t;
    sampleRate = sr;
    stepSize = 60.0/tempo;
    isPlaying = false;
}
//method to make tempo twice as fast or slow
void Clock::scaleTempo(bool up){
    if (up) {
        tempo *= 1.2;
        std::cerr << "UP";
    }
    else {
        tempo /=1.2;
        std::cerr << "DOWN";
    }
    stepSize = 60.0/tempo;
}
    
//keep track of whether steps are the current beat
bool Clock::checkBeat() {
    if (isPlaying == false) return false;
    bool isBeat = false;

    if (timeElapsed < 1.0/sampleRate){
        isBeat = true;
        currentStep = ++currentStep % stepsInGrid;
    }
    timeElapsed += 1.0/sampleRate;
    while (timeElapsed >= stepSize) {
        timeElapsed -= stepSize;
    }

    
    return isBeat;
}
//play tick
void Clock::play() {
    isPlaying = true;
    
}

//pause tick
void Clock::pause() {
    isPlaying = false;
    
}
void Clock::stop() {
    isPlaying = false;
    reset();
    
}
void Clock::reset() {
    currentStep = -1;
    timeElapsed = 0;
    
}

//determine which step we are on
int Clock::whichBeat() {
    return currentStep;
}
