//
//  Cube.cpp
//  
//
//  Created by Melanie on 10/23/14.
//
//

#include "Cube.h"

#ifdef __MACOSX_CORE__
#include <math.h>
#include <GLUT/glut.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#else
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>



#endif

#include <iostream>



//-----------------------------------------------------------------------------
// Class: Square( )
// Desc: draws square objects
//-----------------------------------------------------------------------------

Square::Square() {
    float s = .1;
    this->size = s;
   
};

void Square::draw(bool is_on) {
    if (is_on) {
        glBegin (GL_POLYGON);
    }
    else {
       glBegin (GL_LINE_LOOP);
    }
    glVertex3f(0, 0, 0);
    glVertex3f(this->size, 0, 0);
    glVertex3f(this->size, this->size, 0);
    glVertex3f(0, this->size, 0);
    
    glEnd();
    
    
};



//-----------------------------------------------------------------------------
// Class: Cube( )
// Desc: draws cube objects
//-----------------------------------------------------------------------------


Cube::Cube() {
    float s = .03;
    this->size = s;
    this->top.size = s;
    this->bottom.size = s;
    this->front.size = s;
    this->back.size = s;
    this->left.size = s;
    this->right.size = s;
 

};



void updateColorArray(float (&array)[4],
                      float x,
                      float y,
                      float z,
                      float alpha)
{
    array[0] = x;
    array[1] = y;
    array[2] = z;
    array[3] = alpha;
}


void Cube::draw(CubeType type, bool highlight, bool is_on) {//if it is the current cube it highlights it, if the cube is on it changes from being made with g lines vs. g polygons, and when the cube is being played it is completely filled.     
    float top_color[4] = {1, 1, 0, 0.2};
    float bottom_color[4] = {1, 0, 0, 0.2};
    float front_color[4] = {1, 1, 1, 0.2};
    float back_color[4] = {1, 0, 0.8, 0.2};
    float right_color[4] = {0, 0, 1, 0.2};
    float left_color[4] = {0, 0, 0, 0.2};
    float alpha = .2;
    if (highlight) {
        alpha = 1;
    }
    switch (type) {
        case PITCH:
            updateColorArray(top_color, 0, 1, 0, alpha);
            updateColorArray(bottom_color, 0, 1, 0, alpha);
            updateColorArray(front_color, 0, 1, 0, alpha);
            updateColorArray(back_color, 0, 1, 0, alpha);
            updateColorArray(right_color, 0, 1, 0, alpha);
            updateColorArray(left_color, 0, 1, 0, alpha);
            break;
            
        case VOLUME:
            updateColorArray(top_color, 1, 1, 0, alpha);
            updateColorArray(bottom_color, 1, 0, 0, alpha);
            updateColorArray(front_color, 1, 1, 1, alpha);
            updateColorArray(back_color, 1, 0, .8, alpha);
            updateColorArray(right_color, 0, 0, 1, alpha);
            updateColorArray(left_color, 0, 0, 0, alpha);
            
            break;
            
        case TIMBRE:
            updateColorArray(top_color, 0, 1, 0, alpha);
            updateColorArray(bottom_color, 0, 1, 0, alpha);
            updateColorArray(front_color, 0, 1, 0, alpha);
            updateColorArray(back_color, 0, 1, 0, alpha);
            updateColorArray(right_color, 0, 1, 0, alpha);
            updateColorArray(left_color, 0, 1, 0, alpha);
           
            break;



    }
    
    

    glColor4fv(top_color);  //yellow
    glPushMatrix();
    glTranslatef(0, size, 0);
    glRotatef(270, 1, 0, 0);
    this->top.draw(is_on);
    glPopMatrix();
    
    glColor4fv(bottom_color);  //red
    glPushMatrix();
    glRotatef(270, 1, 0, 0);
    this->bottom.draw(is_on);
    glPopMatrix();
    
    glColor4fv(front_color); //white
    glPushMatrix();
    this->front.draw(is_on);
    glPopMatrix();
    
    glColor4fv(back_color); // green
    glPushMatrix();
    glTranslatef(0, 0, -size);
    this->back.draw(is_on);
    glPopMatrix();
    
    glColor4fv(right_color); // blue
    glPushMatrix();
    glTranslatef(size, 0, 0);
    glRotatef(90, 0, 1, 0);
    this->right.draw(is_on);
    glPopMatrix();
    
    glColor4fv(left_color); // black
    glPushMatrix();
    glRotatef(90, 0, 1, 0);
    
    this->left.draw(is_on);
    glPopMatrix();
    
};





