//
//  melody.h
//  
//
//  Created by Melanie on 11/11/14.
//
//

#ifndef __melody_h__
#define __melody_h__

#include "track.h"
#include <vector>
#include <map>
#include <set>
#include "y-entity.h"
#include "x-gfx.h"


#define NUM_NOTES_IN_MELODY 12  // number of tracks

//two available keys
enum bankKey {
    CMAJOR, AMINOR
};


class Droplet : public YEntity {
    
public:
    Droplet();
    virtual void render();
    
private:
    YCone cone;
    YSphere sphere;
    
};

//themes and variations are both part of melody
class Melody {

public:
    
    Melody(int numSteps, int eyeD, bankKey keyd);
    
    std::vector<Track> melody;
    bankKey key; //M or m
    int length;  //length of the melody in steps
    int melody_id;
    std::map<int, int> skeleton; //step number first and then note
    std::map<int, std::set<int> > inputMelody;  // maps step to a set of notes (tracks)
    
    void renderOne(); //edit mode for one melody
    void renderAll(); //listening mode for all melodies in the fantasy
    
    bool isComplete(); //checks to see if a melody is finished
    void toggleNote(int note, int step);  // note == track
    
    void lockStep(int note, int stepNumber); //turns on notes
    void unLockStep(int note, int stepNumber);//turns off notes
    void newStep (int step);
    
   
    
    virtual void makeSkeleton() = 0; //method for mandatory notes users must incorporate
    Droplet droplet;
    YText text; //text for edit mode
    YText texts; //text for listening mode
   
 
    
private:
    
    
};





#endif
