//
//  Track.cpp
//
//
//  Created by Melanie on 10/23/14.
//
//

#include <iostream>

#include "track.h"
#include "cube.h"
#include "ff_audio.h"
#include "melody.h"
#include "bank.h"

#include "y-fluidsynth.h"
#include "ff_sim.h"
#include "y-fft.h"
#include "y-waveform.h"
#include "ff_me.h"
#include "ff_globals.h"
using namespace std;

#ifdef __MACOSX_CORE__

#include <GLUT/glut.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#else
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#endif


#define NUM_NOTES 12

//calls draw cube function
void Step::renderCubes(bool highlight) {

    
    glPushMatrix();
    glRotatef(35, 0.3, 1, 0.1);
    if (this->is_locked == true) {
        glScalef(1.5, 1.5, 1.5);
    }
    if (this->is_unPlayable == true){
    glRotatef(30, 1, 0, 1);
   
    }
    
    this->pitch.draw(VOLUME, highlight, is_on);

  
    glPopMatrix();

    }



//default is that steps are off
Step::Step() {
    this->is_on = false;
}

//each track has a track id, steps
Track::Track(int number_steps, int id_) {
    for (int i=0; i<number_steps; i++){
       steps.push_back(Step());
    }
    note = id_;
}

Track::~Track() {

}

void Track::newStep(int stepNumber) {
   //plays the correct pitch for whatever track it is, tells the synth what to do
    if (steps[stepNumber].is_on) {
        float pitch = 67;
        int velocity = 127;
        if (note == 0) {
            pitch = 56;
            velocity = 127;
        } else if (note == 1) {
            pitch = 57;
            velocity = 127;
        } else if (note == 2) {
            pitch = 59;
            velocity = 127;
        } else if (note == 3) {
            pitch = 60;
            velocity = 127;
        } else if (note == 4) {
            pitch = 62;
            velocity = 127;
        } else if (note == 5) {
            pitch = 64;
            velocity = 127;
        } else if (note == 6) {
            pitch = 65;
            velocity = 127;
        } else if (note == 7) {
            pitch = 67;
            velocity = 127;
        } else if (note == 8) {
            pitch = 68;
            velocity = 127;
        } else if (note == 9) {
            pitch = 69;
            velocity = 127;
        } else if (note == 10) {
            pitch = 71;
            velocity = 127;
        } else if (note == 11) {
            pitch = 72;
            velocity = 127;
        }

        Globals::synth->programChange( 0, 0 );//change right side
        Globals::synth->noteOn( 0, pitch, velocity );

     }
}

//renders display correctly and in accordance with which track is the active track, and which beat we are on
void Track::renderDisplay() {

    glPushMatrix();

    glPushName(note);
    
    for (int i = 0; i < this->steps.size(); i++) {

        bool highlight = false;
        if (Globals::mainclock.whichBeat()== i) {
            highlight = true;
        }

        glPushName(i);
        this->steps[i].renderCubes(highlight);
        glPopName();

        glTranslatef((1.90 / this->steps.size()), 0, 0);  // horizontal step increment

    }
    glPopName();

    glPopMatrix();


};



//decides whether or not a particular step is on
bool Track::handleCubeInteraction(int stepNumber) {
    this->steps[stepNumber].is_on = !this->steps[stepNumber].is_on;
    return this->steps[stepNumber].is_on;
};



//#endif /* defined(____Track__) */
