//----------------------------------------------------------------------------
// name: fatasticFantasy.cpp
// desc: fatasticFantasy entry point
//
// author: Melanie Goldstein (with lots of code from Ge Wang)
// date: fall 2014
//----------------------------------------------------------------------------
#include <iostream>
#include "ff_audio.h"
#include "ff_gfx.h"
#include "ff_globals.h"
using namespace std;




//----------------------------------------------------------------------------
// name: main()
// desc: application entry point
//----------------------------------------------------------------------------
int main( int argc, const char ** argv )
{
    system( "pwd" );
    // invoke graphics setup and loop
    if( !ff_gfx_init( argc, argv ) )
    {
        // error message
        cerr << "[CubeSequencer]: cannot initialize graphics/data system..." << endl;
        return -1;
    }
    
    // start real-time audio
    if( !ff_audio_init( FF_SRATE, FF_FRAMESIZE, FF_NUMCHANNELS, 1, 2) )
    {
        // error message
        cerr << "[CubeSequencer]: cannot initialize real-time audio I/O..." << endl;
        return -1;
    }
    
    // start audio
    if( !ff_audio_start() )
    {
        // error message
        cerr << "[CubeSequencer]: cannot start real-time audio I/O..." << endl;
        return -1;
    }
    
    // graphics loop
    ff_gfx_loop();
    
    return 0;
}
